/* Utils.c generated by valac 0.56.6, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright (c) 2011-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3, as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

VALA_EXTERN gchar* terminal_utils_sanitize_path (const gchar* _path,
                                     const gchar* shell_location);
VALA_EXTERN gchar* terminal_utils_strip_uri (const gchar* _uri);
VALA_EXTERN gchar* terminal_utils_construct_parent_path (const gchar* path);
VALA_EXTERN gchar* terminal_utils_escape_uri (const gchar* uri,
                                  gboolean allow_utf8,
                                  gboolean allow_single_quote);
VALA_EXTERN gchar* terminal_utils_get_parent_path_from_path (const gchar* path);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 75 "Utils.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 97 "Utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 101 "Utils.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 107 "Utils.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 111 "Utils.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 115 "Utils.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 123 "Utils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 151 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 160 "Utils.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 174 "Utils.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 183 "Utils.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 197 "Utils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 206 "Utils.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 215 "Utils.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 229 "Utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 233 "Utils.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 239 "Utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 244 "Utils.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 250 "Utils.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 254 "Utils.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 258 "Utils.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 262 "Utils.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 266 "Utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 270 "Utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 285 "Utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 294 "Utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 301 "Utils.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 307 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 315 "Utils.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 319 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 325 "Utils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 330 "Utils.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 336 "Utils.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 340 "Utils.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 344 "Utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 350 "Utils.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 356 "Utils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 368 "Utils.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 372 "Utils.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 376 "Utils.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 381 "Utils.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 389 "Utils.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 407 "Utils.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 413 "Utils.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 417 "Utils.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 425 "Utils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 434 "Utils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 443 "Utils.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 449 "Utils.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 457 "Utils.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 469 "Utils.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 475 "Utils.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 479 "Utils.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 487 "Utils.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 498 "Utils.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 507 "Utils.c"
	}
}

gchar*
terminal_utils_sanitize_path (const gchar* _path,
                              const gchar* shell_location)
{
	gchar* scheme = NULL;
	gchar* path = NULL;
	gchar** parts_scheme = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_scheme_length1;
	gint _parts_scheme_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** parts_sep = NULL;
	const gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint parts_sep_length1;
	gint _parts_sep_size_;
	gint index = 0;
	gchar** _tmp28_;
	gint _tmp28__length1;
	const gchar* _tmp29_;
	gchar* _result_ = NULL;
	const gchar* _tmp41_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* result;
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (_path != NULL, NULL);
#line 21 "../src/Utils.vala"
	g_return_val_if_fail (shell_location != NULL, NULL);
#line 25 "../src/Utils.vala"
	_tmp1_ = _tmp0_ = g_strsplit (_path, "://", 2);
#line 25 "../src/Utils.vala"
	parts_scheme = _tmp1_;
#line 25 "../src/Utils.vala"
	parts_scheme_length1 = _vala_array_length (_tmp0_);
#line 25 "../src/Utils.vala"
	_parts_scheme_size_ = parts_scheme_length1;
#line 26 "../src/Utils.vala"
	_tmp2_ = parts_scheme;
#line 26 "../src/Utils.vala"
	_tmp2__length1 = parts_scheme_length1;
#line 26 "../src/Utils.vala"
	if (_tmp2__length1 == 2) {
#line 570 "Utils.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 27 "../src/Utils.vala"
		_tmp3_ = parts_scheme;
#line 27 "../src/Utils.vala"
		_tmp3__length1 = parts_scheme_length1;
#line 27 "../src/Utils.vala"
		_tmp4_ = _tmp3_[0];
#line 27 "../src/Utils.vala"
		_tmp5_ = g_strconcat (_tmp4_, "://", NULL);
#line 27 "../src/Utils.vala"
		_g_free0 (scheme);
#line 27 "../src/Utils.vala"
		scheme = _tmp5_;
#line 28 "../src/Utils.vala"
		_tmp6_ = parts_scheme;
#line 28 "../src/Utils.vala"
		_tmp6__length1 = parts_scheme_length1;
#line 28 "../src/Utils.vala"
		_tmp7_ = _tmp6_[1];
#line 28 "../src/Utils.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 28 "../src/Utils.vala"
		_g_free0 (path);
#line 28 "../src/Utils.vala"
		path = _tmp8_;
#line 603 "Utils.c"
	} else {
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 30 "../src/Utils.vala"
		_tmp9_ = g_strdup ("file://");
#line 30 "../src/Utils.vala"
		_g_free0 (scheme);
#line 30 "../src/Utils.vala"
		scheme = _tmp9_;
#line 31 "../src/Utils.vala"
		_tmp10_ = g_strdup (_path);
#line 31 "../src/Utils.vala"
		_g_free0 (path);
#line 31 "../src/Utils.vala"
		path = _tmp10_;
#line 619 "Utils.c"
	}
#line 34 "../src/Utils.vala"
	_tmp11_ = path;
#line 34 "../src/Utils.vala"
	_tmp12_ = g_uri_unescape_string (_tmp11_, NULL);
#line 34 "../src/Utils.vala"
	_g_free0 (path);
#line 34 "../src/Utils.vala"
	path = _tmp12_;
#line 35 "../src/Utils.vala"
	_tmp13_ = path;
#line 35 "../src/Utils.vala"
	if (_tmp13_ == NULL) {
#line 36 "../src/Utils.vala"
		result = NULL;
#line 36 "../src/Utils.vala"
		parts_scheme = (_vala_array_free (parts_scheme, parts_scheme_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../src/Utils.vala"
		_g_free0 (path);
#line 36 "../src/Utils.vala"
		_g_free0 (scheme);
#line 36 "../src/Utils.vala"
		return result;
#line 643 "Utils.c"
	}
#line 39 "../src/Utils.vala"
	_tmp14_ = path;
#line 39 "../src/Utils.vala"
	_tmp15_ = terminal_utils_strip_uri (_tmp14_);
#line 39 "../src/Utils.vala"
	_g_free0 (path);
#line 39 "../src/Utils.vala"
	path = _tmp15_;
#line 653 "Utils.c"
	{
		gboolean _tmp16_ = FALSE;
#line 41 "../src/Utils.vala"
		_tmp16_ = TRUE;
#line 41 "../src/Utils.vala"
		while (TRUE) {
#line 660 "Utils.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 41 "../src/Utils.vala"
			if (!_tmp16_) {
#line 665 "Utils.c"
				const gchar* _tmp17_;
#line 44 "../src/Utils.vala"
				_tmp17_ = path;
#line 44 "../src/Utils.vala"
				if (!string_contains (_tmp17_, "//")) {
#line 44 "../src/Utils.vala"
					break;
#line 673 "Utils.c"
				}
			}
#line 41 "../src/Utils.vala"
			_tmp16_ = FALSE;
#line 42 "../src/Utils.vala"
			_tmp18_ = path;
#line 42 "../src/Utils.vala"
			_tmp19_ = string_replace (_tmp18_, "//", "/");
#line 42 "../src/Utils.vala"
			_g_free0 (path);
#line 42 "../src/Utils.vala"
			path = _tmp19_;
#line 686 "Utils.c"
		}
	}
#line 46 "../src/Utils.vala"
	_tmp20_ = path;
#line 46 "../src/Utils.vala"
	_tmp22_ = _tmp21_ = g_strsplit (_tmp20_, G_DIR_SEPARATOR_S, 3);
#line 46 "../src/Utils.vala"
	parts_sep = _tmp22_;
#line 46 "../src/Utils.vala"
	parts_sep_length1 = _vala_array_length (_tmp21_);
#line 46 "../src/Utils.vala"
	_parts_sep_size_ = parts_sep_length1;
#line 47 "../src/Utils.vala"
	index = 0;
#line 48 "../src/Utils.vala"
	while (TRUE) {
#line 703 "Utils.c"
		gboolean _tmp23_ = FALSE;
		gchar** _tmp24_;
		gint _tmp24__length1;
		const gchar* _tmp25_;
		gint _tmp27_;
#line 48 "../src/Utils.vala"
		_tmp24_ = parts_sep;
#line 48 "../src/Utils.vala"
		_tmp24__length1 = parts_sep_length1;
#line 48 "../src/Utils.vala"
		_tmp25_ = _tmp24_[index];
#line 48 "../src/Utils.vala"
		if (_tmp25_ == NULL) {
#line 717 "Utils.c"
			gchar** _tmp26_;
			gint _tmp26__length1;
#line 48 "../src/Utils.vala"
			_tmp26_ = parts_sep;
#line 48 "../src/Utils.vala"
			_tmp26__length1 = parts_sep_length1;
#line 48 "../src/Utils.vala"
			_tmp23_ = index < (_tmp26__length1 - 1);
#line 726 "Utils.c"
		} else {
#line 48 "../src/Utils.vala"
			_tmp23_ = FALSE;
#line 730 "Utils.c"
		}
#line 48 "../src/Utils.vala"
		if (!_tmp23_) {
#line 48 "../src/Utils.vala"
			break;
#line 736 "Utils.c"
		}
#line 49 "../src/Utils.vala"
		_tmp27_ = index;
#line 49 "../src/Utils.vala"
		index = _tmp27_ + 1;
#line 742 "Utils.c"
	}
#line 52 "../src/Utils.vala"
	_tmp28_ = parts_sep;
#line 52 "../src/Utils.vala"
	_tmp28__length1 = parts_sep_length1;
#line 52 "../src/Utils.vala"
	_tmp29_ = _tmp28_[index];
#line 52 "../src/Utils.vala"
	if (g_strcmp0 (_tmp29_, "~") == 0) {
#line 752 "Utils.c"
		gchar** _tmp30_;
		gint _tmp30__length1;
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 53 "../src/Utils.vala"
		_tmp30_ = parts_sep;
#line 53 "../src/Utils.vala"
		_tmp30__length1 = parts_sep_length1;
#line 53 "../src/Utils.vala"
		_tmp31_ = g_get_home_dir ();
#line 53 "../src/Utils.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 53 "../src/Utils.vala"
		_g_free0 (_tmp30_[index]);
#line 53 "../src/Utils.vala"
		_tmp30_[index] = _tmp32_;
#line 769 "Utils.c"
	} else {
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
#line 54 "../src/Utils.vala"
		_tmp33_ = parts_sep;
#line 54 "../src/Utils.vala"
		_tmp33__length1 = parts_sep_length1;
#line 54 "../src/Utils.vala"
		_tmp34_ = _tmp33_[index];
#line 54 "../src/Utils.vala"
		if (g_strcmp0 (_tmp34_, ".") == 0) {
#line 782 "Utils.c"
			gchar** _tmp35_;
			gint _tmp35__length1;
			gchar* _tmp36_;
#line 55 "../src/Utils.vala"
			_tmp35_ = parts_sep;
#line 55 "../src/Utils.vala"
			_tmp35__length1 = parts_sep_length1;
#line 55 "../src/Utils.vala"
			_tmp36_ = g_strdup (shell_location);
#line 55 "../src/Utils.vala"
			_g_free0 (_tmp35_[index]);
#line 55 "../src/Utils.vala"
			_tmp35_[index] = _tmp36_;
#line 796 "Utils.c"
		} else {
			gchar** _tmp37_;
			gint _tmp37__length1;
			const gchar* _tmp38_;
#line 56 "../src/Utils.vala"
			_tmp37_ = parts_sep;
#line 56 "../src/Utils.vala"
			_tmp37__length1 = parts_sep_length1;
#line 56 "../src/Utils.vala"
			_tmp38_ = _tmp37_[index];
#line 56 "../src/Utils.vala"
			if (g_strcmp0 (_tmp38_, "..") == 0) {
#line 809 "Utils.c"
				gchar** _tmp39_;
				gint _tmp39__length1;
				gchar* _tmp40_;
#line 57 "../src/Utils.vala"
				_tmp39_ = parts_sep;
#line 57 "../src/Utils.vala"
				_tmp39__length1 = parts_sep_length1;
#line 57 "../src/Utils.vala"
				_tmp40_ = terminal_utils_construct_parent_path (shell_location);
#line 57 "../src/Utils.vala"
				_g_free0 (_tmp39_[index]);
#line 57 "../src/Utils.vala"
				_tmp39_[index] = _tmp40_;
#line 823 "Utils.c"
			}
		}
	}
#line 60 "../src/Utils.vala"
	_tmp41_ = scheme;
#line 60 "../src/Utils.vala"
	_tmp42_ = parts_sep;
#line 60 "../src/Utils.vala"
	_tmp42__length1 = parts_sep_length1;
#line 60 "../src/Utils.vala"
	_tmp43_ = _vala_g_strjoinv (G_DIR_SEPARATOR_S, _tmp42_, (gint) _tmp42__length1);
#line 60 "../src/Utils.vala"
	_tmp44_ = _tmp43_;
#line 60 "../src/Utils.vala"
	_tmp45_ = string_replace (_tmp44_, "//", "/");
#line 60 "../src/Utils.vala"
	_tmp46_ = _tmp45_;
#line 60 "../src/Utils.vala"
	_tmp47_ = g_strconcat (_tmp41_, _tmp46_, NULL);
#line 60 "../src/Utils.vala"
	_tmp48_ = _tmp47_;
#line 60 "../src/Utils.vala"
	_tmp49_ = terminal_utils_escape_uri (_tmp48_, TRUE, TRUE);
#line 60 "../src/Utils.vala"
	_tmp50_ = _tmp49_;
#line 60 "../src/Utils.vala"
	_g_free0 (_tmp48_);
#line 60 "../src/Utils.vala"
	_g_free0 (_tmp46_);
#line 60 "../src/Utils.vala"
	_g_free0 (_tmp44_);
#line 60 "../src/Utils.vala"
	_result_ = _tmp50_;
#line 61 "../src/Utils.vala"
	result = _result_;
#line 61 "../src/Utils.vala"
	parts_sep = (_vala_array_free (parts_sep, parts_sep_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/Utils.vala"
	parts_scheme = (_vala_array_free (parts_scheme, parts_scheme_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/Utils.vala"
	_g_free0 (path);
#line 61 "../src/Utils.vala"
	_g_free0 (scheme);
#line 61 "../src/Utils.vala"
	return result;
#line 869 "Utils.c"
}

/*** Simplified version of PF.FileUtils function, with fewer checks ***/
static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 894 "Utils.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 902 "Utils.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 908 "Utils.c"
	}
}

gchar*
terminal_utils_get_parent_path_from_path (const gchar* path)
{
	gint _tmp0_;
	gint _tmp1_;
	GString* string_builder = NULL;
	GString* _tmp3_;
	gint last_separator = 0;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GString* _tmp11_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 65 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 66 "../src/Utils.vala"
	_tmp0_ = strlen (path);
#line 66 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 66 "../src/Utils.vala"
	if (_tmp1_ < 2) {
#line 935 "Utils.c"
		gchar* _tmp2_;
#line 67 "../src/Utils.vala"
		_tmp2_ = g_strdup (G_DIR_SEPARATOR_S);
#line 67 "../src/Utils.vala"
		result = _tmp2_;
#line 67 "../src/Utils.vala"
		return result;
#line 943 "Utils.c"
	}
#line 70 "../src/Utils.vala"
	_tmp3_ = g_string_new (path);
#line 70 "../src/Utils.vala"
	string_builder = _tmp3_;
#line 71 "../src/Utils.vala"
	if (g_str_has_suffix (path, G_DIR_SEPARATOR_S)) {
#line 951 "Utils.c"
		GString* _tmp4_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 72 "../src/Utils.vala"
		_tmp4_ = string_builder;
#line 72 "../src/Utils.vala"
		_tmp5_ = string_builder;
#line 72 "../src/Utils.vala"
		_tmp6_ = _tmp5_->str;
#line 72 "../src/Utils.vala"
		_tmp7_ = strlen (_tmp6_);
#line 72 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 72 "../src/Utils.vala"
		g_string_erase (_tmp4_, (gssize) (_tmp8_ - 1), (gssize) -1);
#line 969 "Utils.c"
	}
#line 75 "../src/Utils.vala"
	_tmp9_ = string_builder;
#line 75 "../src/Utils.vala"
	_tmp10_ = _tmp9_->str;
#line 75 "../src/Utils.vala"
	last_separator = string_last_index_of (_tmp10_, G_DIR_SEPARATOR_S, 0);
#line 76 "../src/Utils.vala"
	if (last_separator < 0) {
#line 77 "../src/Utils.vala"
		last_separator = 0;
#line 981 "Utils.c"
	}
#line 80 "../src/Utils.vala"
	_tmp11_ = string_builder;
#line 80 "../src/Utils.vala"
	g_string_erase (_tmp11_, (gssize) last_separator, (gssize) -1);
#line 81 "../src/Utils.vala"
	_tmp12_ = string_builder;
#line 81 "../src/Utils.vala"
	_tmp13_ = _tmp12_->str;
#line 81 "../src/Utils.vala"
	_tmp14_ = g_strconcat (_tmp13_, G_DIR_SEPARATOR_S, NULL);
#line 81 "../src/Utils.vala"
	result = _tmp14_;
#line 81 "../src/Utils.vala"
	_g_string_free0 (string_builder);
#line 81 "../src/Utils.vala"
	return result;
#line 999 "Utils.c"
}

gchar*
terminal_utils_construct_parent_path (const gchar* path)
{
	gint _tmp0_;
	gint _tmp1_;
	GString* sb = NULL;
	GString* _tmp3_;
	gint last_separator = 0;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GString* _tmp11_;
	gchar* parent_path = NULL;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
#line 84 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 85 "../src/Utils.vala"
	_tmp0_ = strlen (path);
#line 85 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 85 "../src/Utils.vala"
	if (_tmp1_ < 2) {
#line 1026 "Utils.c"
		gchar* _tmp2_;
#line 86 "../src/Utils.vala"
		_tmp2_ = g_strdup (G_DIR_SEPARATOR_S);
#line 86 "../src/Utils.vala"
		result = _tmp2_;
#line 86 "../src/Utils.vala"
		return result;
#line 1034 "Utils.c"
	}
#line 89 "../src/Utils.vala"
	_tmp3_ = g_string_new (path);
#line 89 "../src/Utils.vala"
	sb = _tmp3_;
#line 91 "../src/Utils.vala"
	if (g_str_has_suffix (path, G_DIR_SEPARATOR_S)) {
#line 1042 "Utils.c"
		GString* _tmp4_;
		GString* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 92 "../src/Utils.vala"
		_tmp4_ = sb;
#line 92 "../src/Utils.vala"
		_tmp5_ = sb;
#line 92 "../src/Utils.vala"
		_tmp6_ = _tmp5_->str;
#line 92 "../src/Utils.vala"
		_tmp7_ = strlen (_tmp6_);
#line 92 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 92 "../src/Utils.vala"
		g_string_erase (_tmp4_, (gssize) (_tmp8_ - 1), (gssize) -1);
#line 1060 "Utils.c"
	}
#line 95 "../src/Utils.vala"
	_tmp9_ = sb;
#line 95 "../src/Utils.vala"
	_tmp10_ = _tmp9_->str;
#line 95 "../src/Utils.vala"
	last_separator = string_last_index_of (_tmp10_, G_DIR_SEPARATOR_S, 0);
#line 96 "../src/Utils.vala"
	if (last_separator < 0) {
#line 97 "../src/Utils.vala"
		last_separator = 0;
#line 1072 "Utils.c"
	}
#line 99 "../src/Utils.vala"
	_tmp11_ = sb;
#line 99 "../src/Utils.vala"
	g_string_erase (_tmp11_, (gssize) last_separator, (gssize) -1);
#line 101 "../src/Utils.vala"
	_tmp12_ = sb;
#line 101 "../src/Utils.vala"
	_tmp13_ = _tmp12_->str;
#line 101 "../src/Utils.vala"
	_tmp14_ = g_strconcat (_tmp13_, G_DIR_SEPARATOR_S, NULL);
#line 101 "../src/Utils.vala"
	parent_path = _tmp14_;
#line 103 "../src/Utils.vala"
	result = parent_path;
#line 103 "../src/Utils.vala"
	_g_string_free0 (sb);
#line 103 "../src/Utils.vala"
	return result;
#line 1092 "Utils.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1113 "Utils.c"
}

gchar*
terminal_utils_strip_uri (const gchar* _uri)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 107 "../src/Utils.vala"
	_tmp0_ = g_strdup (_uri);
#line 107 "../src/Utils.vala"
	uri = _tmp0_;
#line 109 "../src/Utils.vala"
	if (_uri != NULL) {
#line 1128 "Utils.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 110 "../src/Utils.vala"
		_tmp1_ = uri;
#line 110 "../src/Utils.vala"
		_tmp2_ = string_strip (_tmp1_);
#line 110 "../src/Utils.vala"
		_g_free0 (uri);
#line 110 "../src/Utils.vala"
		uri = _tmp2_;
#line 111 "../src/Utils.vala"
		_tmp3_ = uri;
#line 111 "../src/Utils.vala"
		_tmp4_ = string_replace (_tmp3_, "\n", "");
#line 111 "../src/Utils.vala"
		_g_free0 (uri);
#line 111 "../src/Utils.vala"
		uri = _tmp4_;
#line 112 "../src/Utils.vala"
		_tmp5_ = uri;
#line 112 "../src/Utils.vala"
		_tmp6_ = string_replace (_tmp5_, "\r", "");
#line 112 "../src/Utils.vala"
		_g_free0 (uri);
#line 112 "../src/Utils.vala"
		uri = _tmp6_;
#line 1159 "Utils.c"
	}
#line 115 "../src/Utils.vala"
	result = uri;
#line 115 "../src/Utils.vala"
	return result;
#line 1165 "Utils.c"
}

gchar*
terminal_utils_escape_uri (const gchar* uri,
                           gboolean allow_utf8,
                           gboolean allow_single_quote)
{
	gchar* placeholder = NULL;
	gchar* _tmp0_;
	gchar** parts = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* uri_to_escape = NULL;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	gchar* rc = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp20_ = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* result;
#line 118 "../src/Utils.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 120 "../src/Utils.vala"
	_tmp0_ = g_strdup ("::::::");
#line 120 "../src/Utils.vala"
	placeholder = _tmp0_;
#line 121 "../src/Utils.vala"
	_tmp2_ = _tmp1_ = g_strsplit (uri, G_DIR_SEPARATOR_S, 0);
#line 121 "../src/Utils.vala"
	parts = _tmp2_;
#line 121 "../src/Utils.vala"
	parts_length1 = _vala_array_length (_tmp1_);
#line 121 "../src/Utils.vala"
	_parts_size_ = parts_length1;
#line 122 "../src/Utils.vala"
	_tmp3_ = parts;
#line 122 "../src/Utils.vala"
	_tmp3__length1 = parts_length1;
#line 122 "../src/Utils.vala"
	_tmp4_ = parts;
#line 122 "../src/Utils.vala"
	_tmp4__length1 = parts_length1;
#line 122 "../src/Utils.vala"
	_tmp5_ = parts;
#line 122 "../src/Utils.vala"
	_tmp5__length1 = parts_length1;
#line 122 "../src/Utils.vala"
	_tmp6_ = parts;
#line 122 "../src/Utils.vala"
	_tmp6__length1 = parts_length1;
#line 122 "../src/Utils.vala"
	_tmp7_ = _tmp5_[_tmp6__length1 - 1];
#line 122 "../src/Utils.vala"
	_tmp8_ = placeholder;
#line 122 "../src/Utils.vala"
	_tmp9_ = string_replace (_tmp7_, "#", _tmp8_);
#line 122 "../src/Utils.vala"
	_g_free0 (_tmp3_[_tmp4__length1 - 1]);
#line 122 "../src/Utils.vala"
	_tmp3_[_tmp4__length1 - 1] = _tmp9_;
#line 123 "../src/Utils.vala"
	_tmp10_ = parts;
#line 123 "../src/Utils.vala"
	_tmp10__length1 = parts_length1;
#line 123 "../src/Utils.vala"
	_tmp11_ = _vala_g_strjoinv (G_DIR_SEPARATOR_S, _tmp10_, (gint) _tmp10__length1);
#line 123 "../src/Utils.vala"
	uri_to_escape = _tmp11_;
#line 124 "../src/Utils.vala"
	_tmp12_ = string_replace (G_URI_RESERVED_CHARS_GENERIC_DELIMITERS G_URI_RESERVED_CHARS_SUBCOMPONENT_DELIMITERS, "#", "");
#line 124 "../src/Utils.vala"
	_tmp13_ = _tmp12_;
#line 124 "../src/Utils.vala"
	_tmp14_ = string_replace (_tmp13_, "*", "");
#line 124 "../src/Utils.vala"
	_tmp15_ = _tmp14_;
#line 124 "../src/Utils.vala"
	_tmp16_ = string_replace (_tmp15_, "~", "");
#line 124 "../src/Utils.vala"
	_tmp17_ = _tmp16_;
#line 124 "../src/Utils.vala"
	_g_free0 (_tmp15_);
#line 124 "../src/Utils.vala"
	_g_free0 (_tmp13_);
#line 124 "../src/Utils.vala"
	rc = _tmp17_;
#line 129 "../src/Utils.vala"
	if (!allow_single_quote) {
#line 1280 "Utils.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 130 "../src/Utils.vala"
		_tmp18_ = rc;
#line 130 "../src/Utils.vala"
		_tmp19_ = string_replace (_tmp18_, "'", "");
#line 130 "../src/Utils.vala"
		_g_free0 (rc);
#line 130 "../src/Utils.vala"
		rc = _tmp19_;
#line 1291 "Utils.c"
	}
#line 135 "../src/Utils.vala"
	_tmp21_ = uri_to_escape;
#line 135 "../src/Utils.vala"
	_tmp22_ = g_uri_unescape_string (_tmp21_, NULL);
#line 135 "../src/Utils.vala"
	_tmp20_ = _tmp22_;
#line 135 "../src/Utils.vala"
	if (_tmp20_ == NULL) {
#line 1301 "Utils.c"
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 135 "../src/Utils.vala"
		_tmp23_ = uri_to_escape;
#line 135 "../src/Utils.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 135 "../src/Utils.vala"
		_g_free0 (_tmp20_);
#line 135 "../src/Utils.vala"
		_tmp20_ = _tmp24_;
#line 1312 "Utils.c"
	}
#line 134 "../src/Utils.vala"
	_tmp25_ = rc;
#line 134 "../src/Utils.vala"
	_tmp26_ = g_uri_escape_string (_tmp20_, _tmp25_, allow_utf8);
#line 134 "../src/Utils.vala"
	_tmp27_ = _tmp26_;
#line 134 "../src/Utils.vala"
	_tmp28_ = placeholder;
#line 134 "../src/Utils.vala"
	_tmp29_ = string_replace (_tmp27_, _tmp28_, "#");
#line 134 "../src/Utils.vala"
	_tmp30_ = _tmp29_;
#line 134 "../src/Utils.vala"
	_g_free0 (_tmp27_);
#line 134 "../src/Utils.vala"
	result = _tmp30_;
#line 134 "../src/Utils.vala"
	_g_free0 (_tmp20_);
#line 134 "../src/Utils.vala"
	_g_free0 (rc);
#line 134 "../src/Utils.vala"
	_g_free0 (uri_to_escape);
#line 134 "../src/Utils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/Utils.vala"
	_g_free0 (placeholder);
#line 134 "../src/Utils.vala"
	return result;
#line 1342 "Utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

